#include <systemc.h>
#include "mainsystem.h"
//#include "SimulationManager.h"

//gcdm
void mainsystem::gcd_main()
{

	// datatype for channels
	gcde_parameters gcde_p;
	gcde_results gcde_r;

	// local variables
	sc_uint<8> sample1;
	sc_uint<8> sample2;
	sc_uint<8> result;
	bool err;

	// init
	 err=false;

	while(1)
	{ 

		// main functionality

		// Main input from channel

		 sample1=result8_channel->read();
		 if (sample1==0) err=true;

		 sample2=result16_channel->read();
		 if (sample2==0) err=true;

		//cout<<"sample1: "<<sample1_tmp<<" sample2: "<<sample2_tmp<<endl;

		 if (err==false)
		{
			// fill datatype
			gcde_p.sample1=sample1;
			gcde_p.sample2=sample2;

			// send parameters and receive results
			 gcde_parameters_channel->write(gcde_p);
 			 gcde_r=gcde_results_channel->read();

			// fill local variables
			result=gcde_r.result;
		}	
		else
		{
			 result=0;
			 err=false;
		}

		 result_channel_port->write(result);

		//cout << "GCD: \t\t" << result << "\t at time \t" << sc_time_stamp() << endl;

		
	}
}

//gcde
void mainsystem::gcd_evaluation()
{
	// datatype for channels
	gcde_parameters gcde_p;
	gcde_results gcde_r;

	// local variables
	sc_uint<8>  sample1;
	sc_uint<8>  sample2;

	while(1)
	{

		// read parameters from channel
		gcde_p=gcde_parameters_channel->read();

		// fill local variables
		sample1=gcde_p.sample1;
		sample2=gcde_p.sample2;

		while(sample1!=sample2)
		{
			 if (sample1>sample2)
			{
				 sample1=sample1-sample2;
			}
			else
			{
				 sample2= sample2-sample1;
			}
		}
		
		// fill datatype
		gcde_r.result=sample1;

		// send results to channel
		 gcde_results_channel->write(gcde_r);

	}
}
