#ifndef __GCD__
#define __GCD__

#include "sc_csp_channel_ifs.h"
#include "sc_csp_channel.h"
#include "datatype.h"
#include "timing.h"
#include "sim_param.h"

extern sc_core::sc_time processTime[NPS];
extern int profProc[NPS];
extern std::string procName[NPS];
extern sc_event schedule[NPS];
extern sc_event done[NPS];
extern bool running[NPS];

SC_MODULE(gcd)
{  
	// Ports for external channels
	sc_port< sc_csp_channel_in_if< sc_uint<8> > > in1_channel_port;
	sc_port< sc_csp_channel_in_if< sc_uint<8> > > in2_channel_port;
	sc_port< sc_csp_channel_out_if< sc_uint<8> > > result_channel_port;

	// Internal channels

  SC_CTOR(gcd)
  {      
	  
	SC_THREAD(main);
	SC_THREAD(evaluation);
  }
	// Processes
	void main();

	// Fake processes
	void evaluation();
};

#endif
